package com.vpn.fastestvpnservice.retrofit

import com.vpn.fastestvpnservice.beans.DataResponse
import com.vpn.fastestvpnservice.beans.UserResponse
import retrofit2.Call
import retrofit2.http.Field
import retrofit2.http.FormUrlEncoded
import retrofit2.http.GET
import retrofit2.http.POST

interface Api {

    @FormUrlEncoded
    @POST("authenticate")
    fun login(
        @Field("email") email: String?, @Field("password") password: String?,
        @Field("platform") platform: String?, @Field("version") version: String?,
        @Field("app_version") app_version: String?
    ): Call<Any?>

    @FormUrlEncoded
    @POST("fcm")
    fun sendFcmToken(
        @Field("device") device: String?, @Field("token") token: String?
    ): Call<Any>

    @FormUrlEncoded
    @POST("signup")
    fun signup(
        @Field("email") email: String?, @Field("password") password: String?, @Field("name") name: String?
    ): Call<Any?>

    @POST("logout")
    fun logout(): Call<Any>

    @POST("me/delete")
    fun deleteAccount(): Call<Any>

    @FormUrlEncoded
    @POST("favourites")
    fun setFavUnfav(
        @Field("server_id") serverId: String?
    ): Call<Any>

    @GET("http://ip-api.com/json")
    fun getIp(): Call<Any>

    @GET("servers")
    fun serverDataApi(): Call<Any>

    @GET("notifications")
    fun getNotifications(): Call<Any>

    @FormUrlEncoded
    @POST("validate")
    fun validatePassword(
        @Field("email") email: String?, @Field("password") password: String?,
        @Field("platform") platform: String?, @Field("version") version: String?
    ): Call<Any>?

    @GET("products")
    fun getProducts(): Call<Any>

}