package com.vpn.fastestvpnservice.sealedClass

import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.automirrored.filled.Help
import androidx.compose.material.icons.filled.AccountCircle
import androidx.compose.material.icons.filled.Help
import androidx.compose.material.icons.filled.Home
import androidx.compose.material.icons.filled.Settings
import androidx.compose.ui.graphics.painter.Painter
import androidx.compose.ui.graphics.vector.ImageVector
import androidx.compose.ui.res.painterResource
import com.vpn.fastestvpnservice.R

sealed class BottomBarScreen(
    val route: String,
    val title: String,
    val icon: Int,
    var isTrue: Boolean = false
) {
    data object Home : BottomBarScreen(
        route = "home",
        title = "Home",
        icon = R.drawable.homeicon3
    )
    data object Settings : BottomBarScreen(
        route = "settings",
        title = "Settings",
        icon = R.drawable.settingsicon3x
    )
    data object Help : BottomBarScreen(
        route = "help",
        title = "Help",
        icon = R.drawable.helpicon3x
    )
    data object Account : BottomBarScreen(
        route = "account",
        title = "Account",
        icon = R.drawable.accounticon3x
    )
}